var old_date_type = 0;

function $G(s) {
    return (typeof s == 'object') ? s : document.getElementById(s);
}

function date_click(date_type) {
    var value_year = $G("date_year").value;
    var value_month = $G("date_month").value;
    var value_day = $G("date_day").value;
    $G("birthday_type").value = date_type;

    if (old_date_type != date_type) {
        if (date_type == 1) {
            //阴历转换为阳历：
            var D = new glYear(value_year, value_month, value_day);
            show_date(D.year, D.month, D.day);
            document.getElementById("date_type1").className = "aui-tab-item aui-active";
            document.getElementById("date_type2").className = "aui-tab-item";
        } else {
            //阳历转换为阴历：
            var D = new nlYear(value_year, value_month, value_day);
            show_lunar(D.year[0], D.month[0], D.day[0]);
            document.getElementById("date_type1").className = "aui-tab-item";
            document.getElementById("date_type2").className = "aui-tab-item aui-active";
        }
        old_date_type = date_type;
    }
}

function date_change(value_year, value_month, value_day) {
    if ($G("birthday_type").value == 1) {
        show_date(value_year, value_month, value_day);
    } else {
        show_lunar(value_year, value_month, value_day);
    }
}

function show_date(date_year, date_month, date_day) {
    if (old_date_type == 0) {
        old_date_type = 1;
    }
    var now = new Date();

    var year = $G("date_year");
    year.length = 0;

    year.options[year.length++].value = "";
    year.options[year.length - 1].text = "年";

    for (i = 1950; i <= now.getFullYear(); i++) {
        year.options[year.length++].value = i;
        year.options[year.length - 1].text = i + "年";
    }

    if (date_year + "" != "" && date_year >= 1950) {
        year.value = date_year;
    } else {
        year.value = "";
    }

    var month = $G("date_month");
    month.length = 0;

    month.options[month.length++].value = "";
    month.options[month.length - 1].text = "月";
    for (i = 1; i <= 12; i++) {
        month.options[month.length++].value = i;
        month.options[month.length - 1].text = i + "月";
    }

    if (date_month) {
        month.value = date_month;
    } else {
        month.value = "";
    }

    var day = $G("date_day");
    day.length = 0;
    day.options[day.length++].value = "";
    day.options[day.length - 1].text = "日";
    for (i = 1; i <= (new Date(year.value, month.value, 0)).getDate(); i++) {
        day.options[day.length++].value = i;
        day.options[day.length - 1].text = i + "日";
    }

    if (date_day) {
        day.value = date_day;
    } else {
        day.value = "";
    }
}

//显示阴历
function show_lunar(lunar_year, lunar_month, lunar_day) {
    if (old_date_type == 0) {
        old_date_type = 2;
    }
    var methodObj = new methodYear();
    var now = new Date();

    var year = $G("date_year");
    year.length = 0;
    year.options[year.length++].value = "";
    year.options[year.length - 1].text = "";
    for (i = 1950; i <= now.getFullYear(); i++) {
        year.options[year.length++].value = i;
        year.options[year.length - 1].text = methodObj.getTianDi(i - 1900 + 36) + methodObj.getYMD(0) + "(" + methodObj.getYear(i) + ")";
    }

    if (lunar_year + "" != "" && lunar_year >= 1950) {
        year.value = lunar_year;
    } else {
        year.value = "";
    }
    var leap = methodObj.leapMonth(year.value); //获取闰月

    var month = $G("date_month");
    month.length = 0;
    month.options[month.length++].value = "";
    month.options[month.length - 1].text = "";
    for (i = 1; i <= 12; i++) {
        if (leap == i) {
            month.options[month.length++].value = i;
            month.options[month.length - 1].text = methodObj.getMonth(i, false) + methodObj.getYMD(1);

            month.options[month.length++].value = 100 + i;
            month.options[month.length - 1].text = methodObj.getMonth(i, true) + methodObj.getYMD(1);
        } else {
            month.options[month.length++].value = i;
            month.options[month.length - 1].text = methodObj.getMonth(i, false) + methodObj.getYMD(1);
        }
    }

    if (lunar_month) {
        month.value = lunar_month;
    } else {
        month.value = "";
    }

    var day = $G("date_day");
    day.length = 0;
    if (month.value > 100) {
        var month_day = methodObj.leapDays(year.value); //闰月的天数
    } else {
        var month_day = methodObj.monthDays(year.value, month.value);
    }
    day.options[day.length++].value = "";
    day.options[day.length - 1].text = "";
    for (i = 1; i <= month_day; i++) {
        day.options[day.length++].value = i;
        day.options[day.length - 1].text = methodObj.getDate(i);
    }

    if (lunar_day) {
        day.value = lunar_day;
    } else {
        day.value = "";
    }
}

///////////外部类：
/******************************************************
 *	阳历转换为阴历
 *	var obj=new nlYear();//创建自定义对象
 *	var obj=new nlYear(1980);
 *	var obj=new nlYear(1980,1);
 *	var obj=new nlYear(1980,1,1);
 *	var obj=new nlYear("1980-1-1");
 *******************************************************/
var nlYear = function() {
    var methodObj = new methodYear();
    var i = 0;
    var leap = 0;
    var temp = 0;
    var D = null;
    if (arguments[0]) {
        var tmp_y = arguments[0] + "";
        if (tmp_y.indexOf("-") != -1) {
            var temp_date = tmp_y.split("-");
            tmp_y = temp_date[0];
            tmp_m = temp_date[1];
            tmp_d = temp_date[2];
        } else {
            var tmp_m = 1;
            var tmp_d = 1;
            if (arguments[1]) {
                tmp_m = arguments[1];

                if (arguments[2]) {
                    tmp_d = arguments[2];
                }
            }
        }

        D = new Date(tmp_y, tmp_m - 1, tmp_d);
    } else {
        D = new Date();
    }

    var baseDate = new Date(1900, 0, 31);
    var offset = (D - baseDate) / 86400000; //获取今天是多少天数

    //循环年
    for (i = 1900; i < 2050 && offset > 0; i++) {
        temp = methodObj.lYearDays(i); //获取每年的天数
        offset -= temp;
    }

    if (offset < 0) {
        offset += temp;
        i--;
    }
    var year = i; //当前年份
    var leap = methodObj.leapMonth(i); //获取闰月
    var isLeap = false; //是否闰月

    //获取当前月份是否闰月//offset目前是当年的天数，然后逐月减去当月天数，获取当前月份
    for (i = 1; i < 13 && offset > 0; i++) {
        if (leap > 0 && i == (leap + 1) && isLeap == false) {
            i--;
            isLeap = true;
            temp = methodObj.leapDays(year); //闰月的天数
        } else {
            temp = methodObj.monthDays(year, i); //非闰月的天数
        }
        if (isLeap == true && i == (leap + 1)) {
            isLeap = false;
        }
        offset -= temp;
    }

    //这个是特殊情况，月首，基本不会存在
    if (offset == 0 && leap > 0 && i == leap + 1) {
        if (isLeap) {
            isLeap = false;
        } else {
            isLeap = true;
            i--;
        }
    }
    //获取本月的日份、月份
    if (offset < 0) {
        offset += temp;
        i--;
    }

    var month = i; //月份
    var day = offset + 1; //日份
    this.isLeap = isLeap; //是否闰月

    this.year = [year, methodObj.getTianDi(year - 1900 + 36) + methodObj.getYMD(0) + "(" + methodObj.getYear(year) + ")"];
    this.month = [isLeap ? 100 + month : month, methodObj.getMonth(month, isLeap) + methodObj.getYMD(1)];
    this.day = [Math.floor(day), methodObj.getDate(day)];
}

//反向转换，农历转换为公历
/******************************************************
 *	农历对象，使用方法【只能用到2050.12】
 *	var obj=new glYear(1980,1,1);
 *	月份如果是闰月则以100+月份表示，例如润5月就是105
 *******************************************************/
var glYear = function() {
    //获取农历的年月日参数
    var nl_year = 0,
        nl_month = 0,
        nl_day = 0;
    if (arguments[0]) {
        var nl_year = arguments[0];
        var nl_month = 1;
        var nl_day = 1;
        if (arguments[1]) {
            nl_month = arguments[1];

            if (arguments[2]) {
                nl_day = arguments[2];
            }
        }
    }
    //判断日期范围：
    if (nl_year < 1900 && nl_year > 2050) {
        alert("日期超过范围，只可转换1900-2050期间内的日期！")
        return false;
    }

    //转换为公历日期的主要思路就是获取时间戳
    var methodObj = new methodYear();
    var offset = 0;
    var i = 0;
    var temp = 0;

    //获取到去年年底的天数
    for (i = 1900; i < nl_year; i++) {
        temp = methodObj.lYearDays(i); //当前年的天数
        offset += temp;
    }
    //alert(nl_month)
    //判断是否闰月
    var leap = methodObj.leapMonth(nl_year); //获取闰月
    var isLeap = false; //是否闰月
    if (nl_month > 100) {
        var temp_month = nl_month - 100;
        if (temp_month == leap) {
            isLeap = true;
        }
        nl_month = temp_month;
    }

    //加上截止至上月月份的天数
    //获取当前月份是否闰月//offset目前是当年的天数，然后逐月减去当月天数，获取当前月份
    var temp_isLeap = false;
    for (i = 1; i <= nl_month; i++) {
        if (leap > 0 && i == (leap + 1) && temp_isLeap == false) {
            i--;
            temp_isLeap = true;
            temp = methodObj.leapDays(nl_year); //闰月的天数
        } else {
            temp = methodObj.monthDays(nl_year, i); //非闰月的天数
        }
        if (temp_isLeap == true && i == (leap + 1)) {
            temp_isLeap = false;
        }

        offset += temp;
    }
    offset = offset - (temp - nl_day + 1);

    if (isLeap) {
        offset += methodObj.monthDays(nl_year, leap); //非闰月的天数
    }

    var D = new Date(offset * 86400000 + (new Date(1900, 0, 31)).getTime());

    this.year = D.getFullYear();
    this.month = D.getMonth() + 1;
    this.day = D.getDate();
}

/******************************************************
 *	农历计算方法集合对象，使用方法
 *	var obj=new methodYear();//创建自定义对象
 *******************************************************/
var methodYear = function() {
    var lunarInfo = new Array(19416, 19168, 42352, 21717, 53856, 55632, 91476, 22176, 39632, 21970, 19168, 42422, 42192, 53840, 119381, 46400, 54944, 44450, 38320, 84343, 18800, 42160, 46261, 27216, 27968, 109396, 11104, 38256, 21234, 18800, 25958, 54432, 59984, 28309, 23248, 11104, 100067, 37600, 116951, 51536, 54432, 120998, 46416, 22176, 107956, 9680, 37584, 53938, 43344, 46423, 27808, 46416, 86869, 19872, 42448, 83315, 21200, 43432, 59728, 27296, 44710, 43856, 19296, 43748, 42352, 21088, 62051, 55632, 23383, 22176, 38608, 19925, 19152, 42192, 54484, 53840, 54616, 46400, 46496, 103846, 38320, 18864, 43380, 42160, 45690, 27216, 27968, 44870, 43872, 38256, 19189, 18800, 25776, 29859, 59984, 27480, 21952, 43872, 38613, 37600, 51552, 55636, 54432, 55888, 30034, 22176, 43959, 9680, 37584, 51893, 43344, 46240, 47780, 44368, 21977, 19360, 42416, 86390, 21168, 43312, 31060, 27296, 44368, 23378, 19296, 42726, 42208, 53856, 60005, 54576, 23200, 30371, 38608, 19415, 19152, 42192, 118966, 53840, 54560, 56645, 46496, 22224, 21938, 18864, 42359, 42160, 43600, 111189, 27936, 44448);

    this.getYMD = function() {
        var nyr = new Array("年", "月", "日");
        return nyr[arguments[0]];
    }

    this.lYearDays = function() {
        var sum = 348;
        var y = arguments[0];
        for (var i = 32768; i > 8; i >>= 1) {
            sum += (lunarInfo[y - 1900] & i) ? 1 : 0;
        }
        return (sum + this.leapDays(y));
    }

    this.leapDays = function() {
        var y = arguments[0];
        if (this.leapMonth(y)) {
            return ((lunarInfo[y - 1900] & 65536) ? 30 : 29);
        } else {
            return (0);
        }
    }

    this.leapMonth = function() {
        return (lunarInfo[arguments[0] - 1900] & 15);
    }

    this.monthDays = function() {
        return ((lunarInfo[arguments[0] - 1900] & (65536 >> arguments[1])) ? 30 : 29);
    }

    this.getTianDi = function() {
        var tiangan = new Array("甲", "乙", "丙", "丁", "戊", "己", "庚", "辛", "壬", "癸");
        var dizhi = new Array("子", "丑", "寅", "卯", "辰", "巳", "午", "未", "申", "酉", "戌", "亥");
        var yearTmp = Math.floor(arguments[0]);
        return (tiangan[yearTmp % 10] + dizhi[yearTmp % 12]);
    }

    this.getYear = function() {
        return arguments[0];
        return this.getTianDi(arguments[0] - 1900 + 36);
    }

    this.getMonth = function() {
        var monthNong = new Array("正", "正", "二", "三", "四", "五", "六", "七", "八", "九", "十", "冬", "腊");
        if (arguments[1]) {
            return ("\u95F0" + monthNong[arguments[0]]);
        }
        return monthNong[arguments[0]];
    }

    this.getDate = function() {
        var nStr1 = new Array("一", "二", "三", "四", "五", "六", "七", "八", "九", "十");
        var nStr2 = new Array("初", "十", "廿", "卅", "　");
        var day = "";
        var d = Math.floor(arguments[0]);
        switch (d) {
            case 10:
                {
                    day = "初十";
                    break;
                }
            case 20:
                {
                    day = "二十";
                    break;
                }
            case 30:
                {
                    day = "三十";
                    break;
                }
            default:
                {
                    day = nStr2[Math.floor(d / 10)];day += nStr1[d % 10 - 1];
                }
        }
        return day;
    }
}
